#!/usr/bin/python
# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4

import sys
from optparse import OptionParser
from imagetools import render_oxdb_poster

def main():
    parser = OptionParser()
    parser.add_option('-o', '--oxdbid', dest='oxdb_id', help='0xDB Id')
    parser.add_option('-i', '--imdbid', dest='imdb_id', help='IMDb Id')
    parser.add_option('-t', '--title', dest='title', help='Title')
    parser.add_option('-d', '--director', dest='director', help='Director(s)', default='')
    parser.add_option('-y', '--year', dest='year', help='Year')
    parser.add_option('-s', '--series', dest='series', help='Movie is an episode of a series', action='store_true')
    parser.add_option('-f', '--frame', dest='frame', help='Poster frame (image file to be read)')
    parser.add_option('-l', '--timeline', dest='timeline', help='Timeline (image file to be read)')
    parser.add_option('-p', '--poster', dest='poster', help='Poster (image file to be written)')
    (options, args) = parser.parse_args()

    if None in (options.oxdb_id, options.title, options.poster):
        parser.print_help()
        sys.exit()

    opt = {}
    for key in ('oxdb_id', 'imdb_id', 'title', 'director', 'year', 'series', 'frame', 'timeline', 'poster'):
        opt[key] = getattr(options, key)
        
    opt['title'] = opt['title'].decode('utf-8')
    opt['director'] = opt['director'].decode('utf-8')

    render_oxdb_poster(**opt)
