#!/usr/bin/python
# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4

import sys
from optparse import OptionParser
from imagetools import render_padma_poster

def main():
    parser = OptionParser()
    parser.add_option('-i', '--id', dest='id', help='Pad.ma Id')
    parser.add_option('-t', '--title', dest='title', help='Title', default='')
    parser.add_option('-f', '--frame', dest='frame', help='Poster frame (image file to be read)')
    parser.add_option('-l', '--timeline', dest='timeline', help='Timeline (image file to be read)')
    parser.add_option('-p', '--poster', dest='poster', help='Poster (image file to be written)')
    (options, args) = parser.parse_args()
    if None in (options.id, options.poster):
        parser.print_help()
        sys.exit()
    opt = {}
    for key in ('id', 'title', 'frame', 'timeline', 'poster'):
        opt[key] = getattr(options, key)
        
    opt['title'] = opt['title'].decode('utf-8')

    render_padma_poster(**opt)
